// TestWinDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestWin.h"
#include "TestWinDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "WUSBdrv.h"

UINT ReadLoopRoutine(void* param);
UINT ReadSinglePacketRoutine(void* param);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestWinDlg dialog

CTestWinDlg::CTestWinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestWinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestWinDlg)
	m_iomask = 0;
	m_read = 0;
	m_write = 0;
	m_readdata = _T("0");
	m_paketsize = 512;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestWinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestWinDlg)
	DDX_Text(pDX, IDC_IOMASK, m_iomask);
	DDX_Text(pDX, IDC_READ, m_read);
	DDX_Text(pDX, IDC_WRITE, m_write);
	DDX_Text(pDX, IDC_READ_LOOP_COUNTER, m_readdata);
	DDX_Text(pDX, IDC_PAKET_SIZE, m_paketsize);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestWinDlg, CDialog)
	//{{AFX_MSG_MAP(CTestWinDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	ON_BN_CLICKED(IDC_BUTTON2, OnSetup)
	ON_BN_CLICKED(IDC_BUTTON3, OnWrite)
	ON_BN_CLICKED(IDC_BUTTON4, OnRead)
	ON_BN_CLICKED(IDC_BUTTON5, OnStartReadLoop)
	ON_BN_CLICKED(IDC_BUTTON6, OnStopReadLoop)
	ON_BN_CLICKED(IDC_BUTTON8, OnGetFifoStatus)
	ON_BN_CLICKED(IDC_BUTTON7, OnReadSinglePacket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestWinDlg message handlers

BOOL CTestWinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	ResetByteCounter();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestWinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestWinDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestWinDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestWinDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	int status = WUSB_Open();
	if(status == WUSB_ERROR)
	{		
		MessageBox("ERROR! Can`t open WodmanUSB device", "Info", MB_ICONERROR);		
	}
	else
	{
		MessageBox("Open OK", "Info", MB_ICONINFORMATION);		
	}	

	
}

//****************************************************************************
void CTestWinDlg::OnSetup() 
{
	// TODO: Add your control notification handler code here	
	UpdateData(true);

	if(m_iomask < 0 || m_iomask > 255)
	{
		MessageBox("Bad IO_Mask value", "Info", MB_ICONERROR);
		return;
	}

	WUSB_SetupPortA(m_iomask);	

	MessageBox("IOMask was sucsesfully set", "Info", MB_ICONINFORMATION);	
}

//****************************************************************************
void CTestWinDlg::OnWrite() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	if(m_write < 0 || m_write > 255)
	{
		MessageBox("Bad Write Data value", "Info", MB_ICONERROR);
		return;
	}

	WUSB_WritePortA(m_write);	
}

//****************************************************************************
void CTestWinDlg::OnRead() 
{
	// TODO: Add your control notification handler code here
	unsigned char byte = 0; 
	WUSB_ReadPortA(&byte);

	m_read = byte;
	UpdateData(false);
}

//****************************************************************************
void CTestWinDlg::OnStartReadLoop() 
{
	// TODO: Add your control notification handler code here
	Terminate = false;
	ResetByteCounter();
	AfxBeginThread(ReadLoopRoutine, this);	
}

//****************************************************************************
UINT ReadLoopRoutine(void* param)
{
	CTestWinDlg* dlg = (CTestWinDlg*)param;

	WUSB_SetupPortB(ASYNC_MODE);		//   
	
	char buf[512]; 		

	unsigned int dwRead;
	int status;

	FILE* fl = fopen("DataUSB.txt", "wb");
	if(fl == NULL)
	{
		MessageBox(NULL, "Open file Error", "", MB_ICONERROR);
		return 0;
	}

	while(!dlg->Terminate)
	{
		status = WUSB_ReadPortB(buf, sizeof(buf), &dwRead);
		if(status == WUSB_ERROR)
		{
			MessageBox(NULL, "Read Error!", "", MB_ICONERROR);
			break;
		} 
		else if(status == WUSB_TIMEOUT)
		{
			MessageBox(NULL, "TIMEOUT", "", MB_ICONERROR);
			break;
		}

		dlg->UpdateByteCounter(dwRead);		

		fwrite(buf, dwRead, 1, fl);
	}


	fclose(fl);

	return 0;
}

//****************************************************************************
void CTestWinDlg::UpdateByteCounter(unsigned int WriteSize)
{
	ByteCounter += WriteSize;	
}

//****************************************************************************
void CTestWinDlg::ResetByteCounter()
{
	ByteCounter = 0;
	m_readdata = "0";
	UpdateData(false);
}

//****************************************************************************
void CTestWinDlg::OnStopReadLoop() 
{
	// TODO: Add your control notification handler code here
	Terminate = true;
	m_readdata.Format("%d", ByteCounter);
	UpdateData(false);
}

//****************************************************************************
void CTestWinDlg::OnGetFifoStatus() 
{
	// TODO: Add your control notification handler code here

	unsigned char INstatus  = 0;
	unsigned char OUTstatus = 0;

	int status = WUSB_GetFIFOStatus(&INstatus, &OUTstatus);

	if(status == WUSB_ERROR)
	{		
		MessageBox("ERROR get Status!", "Info", MB_ICONERROR);
		return ;
	}

	CString s1;
	s1.Format(" INFIFO: %d\nOUTFIFO: %d", INstatus, OUTstatus);

	MessageBox(s1, "Info", MB_ICONINFORMATION);
	
}

//****************************************************************************
void CTestWinDlg::OnReadSinglePacket() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	AfxBeginThread(ReadSinglePacketRoutine, this);	
}

//****************************************************************************
UINT ReadSinglePacketRoutine(void* param)
{
	CTestWinDlg* dlg = (CTestWinDlg*)param;

	WUSB_SetupPortB(ASYNC_MODE);		//   	

	
	unsigned int pakSize = dlg->m_paketsize;
	if(pakSize % 512 != 0)
	{
		MessageBox(NULL, "Invalid read\npaket size", "", MB_ICONERROR);
		return 0;
	}


	FILE* fl = fopen("DataUSB.txt", "wb");
	if(fl == NULL)
	{
		MessageBox(NULL, "Open file Error", "", MB_ICONERROR);
		return 0;
	}


	char* buf = new char[pakSize]; 
	unsigned int dwRead;	


	int status = WUSB_ReadPortB(buf, pakSize, &dwRead);
	if(status == WUSB_ERROR)
	{
		MessageBox(NULL, "Read Error!", "", MB_ICONERROR);
		return 0;
	} 
	else if(status == WUSB_TIMEOUT)
	{
		MessageBox(NULL, "TIMEOUT", "", MB_ICONERROR);
		return 0;
	}
	
	fwrite(buf, dwRead, 1, fl);
	fclose(fl);

	CString s;
	s.Format("Read: %d bytes", dwRead);
	MessageBox(NULL, s, "", MB_OK);
	

	return 0;
}


//****************************************************************************
